# SourcePath: ncurses/20070306dev
Summary: A CRT screen handling and optimization package.
Name: sony-target-srel-ncurses
%define pkgname %{sony_target_config}-srel-ncurses
Version: 5.6
Release: 040501
URL: http://www.gnu.org/software/ncurses
Source: ncurses-%{version}.tar.gz
Source1: hhl-libopt-build-ncurses

# LOT scripts
Source10: sony-ncurses-libopt-build-libform
Source11: sony-ncurses-libopt-build-libmenu
Source12: sony-ncurses-libopt-build-libncurses
Source13: sony-ncurses-libopt-build-libpanel

Patch1: ncurses_%{version}-pic.diff
License: Other
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{sony_cross_target_dir}
%define _docdir	%{sony_cross_target_dir}%{sony_target_rel_doc_dir}

%description
The curses library routines are a terminal-independent method of
updating character screens with reasonable optimization.  The ncurses
(new curses) library is a freely distributable replacement for the
discontinued 4.4BSD classic curses library.

Ncurses also contains libtermcap functionality and should be linked
into programs instead of libtermcap.

%package -n %{pkgname}
Summary: A CRT screen handling and optimization package.
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
The curses library routines are a terminal-independent method of
updating character screens with reasonable optimization.  The ncurses
(new curses) library is a freely distributable replacement for the
discontinued 4.4BSD classic curses library.

Ncurses also contains libtermcap functionality and should be linked
into programs instead of libtermcap.

%prep
%setup -q -n ncurses-%{version}
%patch1 -p1

%build
# for sslibc
mv configure{,.org} 
sed 's/-stats,-lc/-stats,-lsonyc/' configure.org > configure
chmod +x configure
# We build a full version for the host... easy way to get a runable tic
mkdir HOSTOBJDIR
cd HOSTOBJDIR
../configure --disable-shared --without-cxx --without-cxx-binding \
	--without-ada --without-curses-h --disable-termcap CFLAGS="-ffunction-sections -O2 -g" | tee ../build.log
make | tee -a ../build.log

cd ..

%sony_target_rel_setup
%sony_target_rel_configure \
	--with-install-prefix=%{buildroot}%{sony_cross_target_dir} \
	--without-ada \
	--with-profile \
	--with-shared \
	--disable-rpath --enable-echo --enable-overwrite \
	--disable-termcap \
	--with-terminfo-dirs="%{sony_target_rel_lib_dir}/terminfo:%{sony_target_rel_data_dir}/terminfo" CFLAGS="-ffunction-sections -O2 -g"\
	| tee -a ../build.log

make HOSTCC=gcc | tee -a ../build.log

%install
rm -rf %{buildroot}
%sony_target_rel_setup
cd %{sony_objdir}
make GZIP='-9' install | tee -a ../build.log

cp lib/*_pic.a %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/.

### gzip -9 %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_man_dir}/man1/tack.1

for i in `find %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo -type f | sed -e s,%{buildroot},,`; do
 case "$i" in \
 */ansi | \
 */dumb | \
 */linux | \
 */rxvt | \
 */screen | */screen-w | \
 */sun | \
 */vt100 | */vt102 | */vt220 | */vt52 | \
 */xterm | */xterm-color | */xterm-r5 | */xterm-r6 | */xterm-vt220 | \
 */xterm-xfree86) echo "%attr(0644,root,root) $i" >> ncurses-base.filelist;; \
 *) echo "%attr(0644,root,root) $i" >> ncurses-term.filelist;; \
 esac
done

rm -rf %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_man_dir}

# Begin for LOT

# Set Library Optimizer variables
%define _optdir %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/optinfo
%define _libdir %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_lib_dir}

# Install Library Optimizer information (libform)
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/optinfo/libform
install -m 755 %{SOURCE10} %{_optdir}/libform/build
install -m 644 obj_s/fld_*.o  obj_s/frm_*.o obj_s/fty_*.o %{_optdir}/libform/
(cd %{_optdir}/libform; umask 022; %{sony_host_bin_dir}/%{sony_target_config}-libindex %{_libdir}/libform.so -o *.o > index)
(umask 022; echo "/usr/lib/libform.so.5.6" > %{_optdir}/libform/path)

# Install Library Optimizer information (libmenu)
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/optinfo/libmenu
install -m 755 %{SOURCE11} %{_optdir}/libmenu/build
install -m 644 obj_s/m_*.o %{_optdir}/libmenu/
(cd %{_optdir}/libmenu; umask 022; %{sony_host_bin_dir}/%{sony_target_config}-libindex %{_libdir}/libmenu.so -o *.o > index)
(umask 022; echo "/usr/lib/libmenu.so.5.6" > %{_optdir}/libmenu/path)

# Install Library Optimizer information (libncurses)
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/optinfo/libncurses
install -m 755 %{SOURCE12} %{_optdir}/libncurses/build
cd obj_s
install -m 644 lib_*.o hardscroll.o hashmap.o nc_panel.o safe_sprintf.o tty_update.o varargs.o memmove.o vsscanf.o expanded.o legacy_coding.o resizeterm.o wresize.o access.o add_tries.o alloc_entry.o alloc_ttype.o captoinfo.o codes.o comp_captab.o comp_error.o comp_expand.o comp_hash.o comp_parse.o comp_scan.o db_iterator.o doalloc.o fallback.o free_ttype.o getenv_num.o home_terminfo.o init_keytry.o name_match.o names.o parse_entry.o read_entry.o read_termcap.o setbuf.o strings.o tries.o trim_sgr0.o unctrl.o visbuf.o write_entry.o define_key.o hashed_db.o key_defined.o keybound.o keyok.o version.o %{_optdir}/libncurses/
cd -
(cd %{_optdir}/libncurses; umask 022; %{sony_host_bin_dir}/%{sony_target_config}-libindex %{_libdir}/libncurses.so -o *.o > index)
(umask 022; echo "/usr/lib/libncurses.so.5.6" > %{_optdir}/libncurses/path)

# Install Library Optimizer information (libpanel)
mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/optinfo/libpanel
install -m 755 %{SOURCE13} %{_optdir}/libpanel/build
install -m 644 obj_s/p_*.o obj_s/panel.o %{_optdir}/libpanel/
(cd %{_optdir}/libpanel; umask 022; %{sony_host_bin_dir}/%{sony_target_config}-libindex %{_libdir}/libpanel.so -o *.o > index)
(umask 022; echo "/usr/lib/libpanel.so.5.6" > %{_optdir}/libpanel/path)

%clean
rm -rf %{buildroot}

%files -n %{pkgname}
%defattr(-,root,root,-)
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/captoinfo
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/clear
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/infocmp
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/infotocap
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/reset
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/tack
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/tic
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/toe
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/tput
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/tset
%{sony_cross_target_dir}%{sony_target_rel_bin_dir}/ncurses5-config
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/curses.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/cursesapp.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/cursesf.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/cursesm.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/cursesp.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/cursesw.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/cursslk.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/eti.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/etip.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/form.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/menu.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/ncurses.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/ncurses_dll.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/panel.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/term.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/termcap.h
%{sony_cross_target_dir}%{sony_target_rel_include_dir}/unctrl.h
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libcurses.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libcurses.so
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libform.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libform.so
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libform.so.5
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libform.so.5.6
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libform_g.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libform_p.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libform_pic.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libmenu.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libmenu.so
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libmenu.so.5
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libmenu.so.5.6
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libmenu_g.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libmenu_p.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libmenu_pic.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libncurses++.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libncurses.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libncurses.so
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libncurses.so.5
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libncurses.so.5.6
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libncurses_g.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libncurses_p.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libncurses_pic.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libpanel.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libpanel.so
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libpanel.so.5
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libpanel.so.5.6
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libpanel_g.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libpanel_p.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/libpanel_pic.a
%{sony_cross_target_dir}%{sony_target_rel_lib_dir}/terminfo
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/tabset/std
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/tabset/stdcrt
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/tabset/vt100
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/tabset/vt300
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/1/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/2/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/3/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/4/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/5/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/6/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/7/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/8/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/9/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/A/*
##%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/A/Apple_Terminal-ascii
##%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/A/Apple_Terminal-ascii-m
##%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/A/Apple_Terminal-m
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/E/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/L/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/M/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/N/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/P/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/Q/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/X/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/a/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/b/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/c/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/d/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/e/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/f/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/g/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/h/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/i/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/j/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/k/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/l/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/m/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/n/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/o/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/p/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/q/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/r/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/s/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/t/*
##%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/t/tvi-2p
##%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/t/tvi912-2p
##%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/t/tvi920-2p
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/u/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/v/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/w/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/x/*
%{sony_cross_target_dir}%{sony_target_rel_data_dir}/terminfo/z/*

# for LOT
%{sony_cross_target_dir}/usr/lib/optinfo/*


%changelog
* Mon Mar 31 2008 Sony Corporation
- added libopt info.

* Tue Dec  03 2007 Sony Corporation - srel-ncurses
- Initial build.
